/*
    SCRIPT CREACIN TRIGGERS BASE DE DATOS
    Fecha: 16/04/2011
    Autor: Francisco Amador Risquez Teva
    Proyecto: gPV
*/


--
--CAMBIAMOS AL ESQUEMA DE BASE DE DATOS: BD
--
ALTER SESSION SET CURRENT_SCHEMA = BD;


--
--TABLA ELECTRODOMSTICOS. OBTENER ID
--
CREATE OR REPLACE TRIGGER ELECTRODOMESTICOS_TG01
BEFORE INSERT
ON ELECTRODOMESTICOS 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDELECTRODOMESTICO),0)+1 INTO :NEW.IDELECTRODOMESTICO FROM ELECTRODOMESTICOS;
END;


--
--TABLA LOG
--
CREATE OR REPLACE TRIGGER LOG_TG01
BEFORE INSERT
ON LOG 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDLOG),0)+1 INTO :NEW.IDLOG FROM LOG;
END;


--
--TABLA SERVICIOS
--
CREATE OR REPLACE TRIGGER SERVICIOS_TG01
BEFORE INSERT
ON SERVICIOS 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDSERVICIO),0)+1 INTO :NEW.IDSERVICIO FROM SERVICIOS;
END;


--
--TABLA TELEOPERADORES
--
CREATE OR REPLACE TRIGGER TELEOPERADORES_TG01
BEFORE INSERT
ON TELEOPERADORES 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDTELEOPERADOR),0)+1 INTO :NEW.IDTELEOPERADOR FROM TELEOPERADORES;
END;


--
--TABLA TECNICOS
--
CREATE OR REPLACE TRIGGER TECNICOS_TG01
BEFORE INSERT
ON TECNICOS 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDTECNICO),0)+1 INTO :NEW.IDTECNICO FROM TECNICOS;
END;


--
--TABLA ZONAS
--
CREATE OR REPLACE TRIGGER ZONAS_TG01
BEFORE INSERT
ON ZONAS 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDZONA),0)+1 INTO :NEW.IDZONA FROM ZONAS;
END;


--
--TABLA CLIENTES
--
CREATE OR REPLACE TRIGGER CLIENTES_TG01
BEFORE INSERT
ON CLIENTES 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDCLIENTE),0)+1 INTO :NEW.IDCLIENTE FROM CLIENTES;
END;


--
--TABLA PRODUCTOS
--
CREATE OR REPLACE TRIGGER PRODUCTOS_TG01
BEFORE INSERT
ON PRODUCTOS 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDPRODUCTO),0)+1 INTO :NEW.IDPRODUCTO FROM PRODUCTOS;
END;


--
--TABLA PETICIONES
--
CREATE OR REPLACE TRIGGER PETICIONES_TG01
BEFORE INSERT
ON PETICIONES 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDPETICION),0)+1 INTO :NEW.IDPETICION FROM PETICIONES;
END;


--
--TABLA TRABAJOS
--
CREATE OR REPLACE TRIGGER TRABAJOS_TG01
BEFORE INSERT
ON TRABAJOS 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDTRABAJO),0)+1 INTO :NEW.IDTRABAJO FROM TRABAJOS;
END;


--
--TABLA ENCUESTAS
--
CREATE OR REPLACE TRIGGER ENCUESTAS_TG01
BEFORE INSERT
ON ENCUESTAS 
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
    SELECT NVL(MAX(IDENCUESTA),0)+1 INTO :NEW.IDENCUESTA FROM ENCUESTAS;
END;

