/*
    PACKAGE PERSONAL
    Fecha: 24/04/2011
    Autor: Francisco Amador Risquez Teva
    Proyecto: gPV
*/



/*
    ESPECIFICACIN DEL PAQUETE
    SUBSISTEMA PERSONAL
*/
CREATE OR REPLACE PACKAGE BD.PERSONAL AS


    /*
        TELEOPERADOR
    */     
    --RF28
    PROCEDURE INS_TELEOPERADOR( pNombre IN BD.TELEOPERADORES.NOMBRE%TYPE
                              , pApellidos IN BD.TELEOPERADORES.APELLIDOS%TYPE
                              , pNif IN BD.TELEOPERADORES.NIF%TYPE
                              , resultado OUT BD.LOG.RESULTADO%TYPE );
    
    --RF29
    PROCEDURE DEL_TELEOPERADOR( pId IN BD.TELEOPERADORES.IDTELEOPERADOR%TYPE 
                              , resultado OUT BD.LOG.RESULTADO%TYPE ); 

    --RF30
    PROCEDURE RES_TELEOPERADOR( pId IN BD.TELEOPERADORES.IDTELEOPERADOR%TYPE 
                              , resultado OUT BD.LOG.RESULTADO%TYPE );
    
    --RF31
    PROCEDURE UPD_TELEOPERADOR( pId IN BD.TELEOPERADORES.IDTELEOPERADOR%TYPE
                              , pNombre IN BD.TELEOPERADORES.NOMBRE%TYPE
                              , pApellidos IN BD.TELEOPERADORES.APELLIDOS%TYPE
                              , pNif IN BD.TELEOPERADORES.NIF%TYPE
                              , resultado OUT BD.LOG.RESULTADO%TYPE ); 
    
    --RF32
    PROCEDURE GET_TELEOPERADOR( pId IN BD.TELEOPERADORES.IDTELEOPERADOR%TYPE
                              , rs OUT SYS_REFCURSOR);


    /*
        TECNICOS
    */     
    --RF33
    PROCEDURE INS_TECNICO( pNombre IN BD.TECNICOS.NOMBRE%TYPE
                         , pApellidos IN BD.TECNICOS.APELLIDOS%TYPE
                         , pNif IN BD.TECNICOS.NIF%TYPE
                         , pTelMovil IN BD.TECNICOS.TELMOVIL%TYPE
                         , resultado OUT BD.LOG.RESULTADO%TYPE );
    
    --RF34
    PROCEDURE DEL_TECNICO( pId IN BD.TECNICOS.IDTECNICO%TYPE 
                         , resultado OUT BD.LOG.RESULTADO%TYPE ); 

    --RF35
    PROCEDURE RES_TECNICO( pId IN BD.TECNICOS.IDTECNICO%TYPE 
                         , resultado OUT BD.LOG.RESULTADO%TYPE );
    
    --RF36
    PROCEDURE UPD_TECNICO( pId IN BD.TECNICOS.IDTECNICO%TYPE
                         , pNombre IN BD.TECNICOS.NOMBRE%TYPE
                         , pApellidos IN BD.TECNICOS.APELLIDOS%TYPE
                         , pNif IN BD.TECNICOS.NIF%TYPE
                         , pTelMovil IN BD.TECNICOS.TELMOVIL%TYPE
                         , resultado OUT BD.LOG.RESULTADO%TYPE ); 
    
    --RF37
    PROCEDURE GET_TECNICO( pId IN BD.TECNICOS.IDTECNICO%TYPE
                         , rs OUT SYS_REFCURSOR);

    --RF38
    PROCEDURE ASG_SERVICIOTECNICO( pIdServicio IN BD.SERVICIOS.IDSERVICIO%TYPE
                                 , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                 , resultado OUT BD.LOG.RESULTADO%TYPE ); 
                      
    --RF39
    PROCEDURE DSG_SERVICIOTECNICO( pIdServicio IN BD.SERVICIOS.IDSERVICIO%TYPE
                                 , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                 , resultado OUT BD.LOG.RESULTADO%TYPE );

    --RF40
    PROCEDURE GET_SERVICIOSTECNICO( pIdServicio IN BD.SERVICIOS.IDSERVICIO%TYPE
                                  , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                  , rs OUT SYS_REFCURSOR);

    --RF41
    PROCEDURE ASG_ELECTRODOMESTICOTECNICO( pIdElectrodomestico IN BD.ELECTRODOMESTICOS.IDELECTRODOMESTICO%TYPE
                                         , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                         , resultado OUT BD.LOG.RESULTADO%TYPE );

    --RF42
    PROCEDURE DSG_ELECTRODOMESTICOTECNICO( pIdElectrodomestico IN BD.ELECTRODOMESTICOS.IDELECTRODOMESTICO%TYPE
                                         , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                         , resultado OUT BD.LOG.RESULTADO%TYPE );

    --RF43
    PROCEDURE GET_ELECTRODOMESTICOSTECNICO( pIdElectrodomestico IN BD.ELECTRODOMESTICOS.IDELECTRODOMESTICO%TYPE
                                          , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                          , rs OUT SYS_REFCURSOR);

    --RF44
    PROCEDURE ASG_ZONATECNICO( pIdzona IN BD.ZONAS.IDZONA%TYPE
                             , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                             , resultado OUT BD.LOG.RESULTADO%TYPE );

    --RF45
    PROCEDURE DSG_ZONATECNICO( pIdzona IN BD.ZONAS.IDZONA%TYPE
                             , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                             , resultado OUT BD.LOG.RESULTADO%TYPE );

    --RF46
    PROCEDURE GET_ZONASTECNICO( pIdZona IN BD.ZONAS.IDZONA%TYPE
                              , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                              , rs OUT SYS_REFCURSOR);


END PERSONAL;



/*
    CUERPO DEL PAQUETE
    SUBSISTEMA PERSONAL
*/
CREATE OR REPLACE PACKAGE BODY BD.PERSONAL AS

/*
    TELEOPERADOR
*/     
    -- RF28
    PROCEDURE INS_TELEOPERADOR( pNombre IN BD.TELEOPERADORES.NOMBRE%TYPE
                              , pApellidos IN BD.TELEOPERADORES.APELLIDOS%TYPE
                              , pNif IN BD.TELEOPERADORES.NIF%TYPE
                              , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF28 - CASO DE USO: CREAR TELEOPERADOR
        PARAMETROS ENTRADA:
            pNombre:    Nombre del Teleoperador
            pApellidos: Apellidos del Teleoperador
            pNif:       NIF del Teleoperador
        PARAMETROS SALIDA:
            resultado: Informacin del resultado de la operacin.
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT|| '.INS_TELEOPERADOR';
        paramIN       := 'pNombre = ' || pNombre
                      || ' ,pApellidos = ' || pApellidos
                      || ' ,pNif = ' || pNif; 
        dateIN        := SYSDATE;
        resultado     := 'OK. El teleoperador se ha creado con xito';

        -- Insertamos el Teleoperador
        INSERT INTO TELEOPERADORES(nombre, apellidos, nif) 
        VALUES(UPPER(pNombre), UPPER(pApellidos), UPPER(pNif));
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -1 THEN
                        -- Registro duplicado
                        resultado := 'ERROR: El nif del teleoperador ya existe.';
                    WHEN -1400 THEN
                        -- Valor nulo
                        resultado := 'ERROR: Se ha intentado almacenar un valor nulo.' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' || SQLCODE || ' - ' || SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END INS_TELEOPERADOR;


    -- RF29
    PROCEDURE DEL_TELEOPERADOR( pId IN BD.TELEOPERADORES.IDTELEOPERADOR%TYPE 
                              , resultado OUT BD.LOG.RESULTADO%TYPE ) 
    IS
    /*
        RF29 - CASO DE USO: BAJA TELEOPERADOR
        PARAMETROS ENTRADA:
            pId: Identificador del teleoperador
        PARAMETROS SALIDA:
            resultado: Informacin del resultado de la operacin.
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fechaBaja     BD.TELEOPERADORES.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT|| '.DEL_TELEOPERADOR';
        paramIN       := 'pId =' || pId;
        dateIN        := SYSDATE;
        resultado     := 'OK. El teleoperador se ha dado de baja con xito';

        -- Miramos que exista y que no est de baja
        SELECT fxBaja INTO fechaBaja 
        FROM TELEOPERADORES 
        WHERE idTeleoperador = pId;
        
        IF (fechaBaja IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20000,'');        
        END IF;
        
        -- Damos de baja el teleoperador con fecha del sistema
        UPDATE TELEOPERADORES 
        SET fxBaja = SYSDATE
        WHERE idTeleoperador = pId;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: El identificador del teleoperador no existe.';
                    WHEN -20000 THEN
                        -- Teleoperador dado de baja
                        resultado := 'ERROR: El teleoperador ya est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END DEL_TELEOPERADOR;


    -- RF30
    PROCEDURE RES_TELEOPERADOR( pId IN BD.TELEOPERADORES.IDTELEOPERADOR%TYPE 
                              , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF30 - CASO DE USO: RECUPERAR TELEOPERADOR
        PARAMETROS ENTRADA:
            pId: Identificador del teleoperador
        PARAMETROS SALIDA:
            resultado: Informacin del resultado de la operacin.
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fechaBaja     BD.TELEOPERADORES.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.RES_TELEOPERADOR';
        paramIN       := 'pId =' || pId;
        dateIN        := SYSDATE;
        resultado     := 'OK. El teleoperador se ha recuperado con xito';

        -- Miramos que exista y que est de baja
        SELECT fxBaja INTO fechaBaja 
        FROM TELEOPERADORES 
        WHERE idTeleoperador = pId;
        
        IF (fechaBaja IS NULL) THEN
            RAISE_APPLICATION_ERROR(-20000,'');        
        END IF;
        
        --  Recuperamos al teleoperador con fecha del sistema
        UPDATE TELEOPERADORES 
        SET fxBaja = NULL
        WHERE idTeleoperador = pId;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: El identificador del teleoperador no existe.';
                    WHEN -20000 THEN
                        -- Teleoperador dado de baja
                        resultado := 'ERROR: El teleoperador no est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END RES_TELEOPERADOR;


    -- RF31
    PROCEDURE UPD_TELEOPERADOR( pId IN BD.TELEOPERADORES.IDTELEOPERADOR%TYPE
                              , pNombre IN BD.TELEOPERADORES.NOMBRE%TYPE
                              , pApellidos IN BD.TELEOPERADORES.APELLIDOS%TYPE
                              , pNif IN BD.TELEOPERADORES.NIF%TYPE
                              , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF31 - CASO DE USO: MODIFICAR TELEOPERADOR
        PARAMETROS ENTRADA:
            pId: identificador del teleprador
            pNombre: nuevo nombre del teleoperador
            pApellidos: nuevos apellidos del teleoperador
            pNif: nuevo NIF del teleoperador
        PARAMETROS SALIDA:
            ninguno
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fechaBaja     BD.TELEOPERADORES.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.UPD_TELEOPERADOR';
        paramIN       := 'pId = ' || pId
                      || ' ,pNombre = ' || pNombre
                      || ' ,pApellidos = ' || pApellidos
                      || ' ,pNif = ' || pNif;
        dateIN        := SYSDATE;
        resultado     := 'OK. El teleoperador se ha modificado con xito';

        -- Miramos que exista y que no est de baja
        SELECT fxBaja INTO fechaBaja 
        FROM TELEOPERADORES 
        WHERE idTeleoperador = pId;
        
        IF (fechaBaja IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20000,'');        
        END IF;
        
        --  Modidicamos los datos del Teleoperador (nombre, apellidos, nif)
        UPDATE TELEOPERADORES
        SET nombre = UPPER(pNombre)
          , apellidos = UPPER(pApellidos)
          , nif = UPPER(pNif)
        WHERE idTeleoperador = pId;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -1 THEN
                        -- Registro duplicado
                        resultado := 'ERROR: El nif del teleoperador ya existe.';
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: El identificador del teleoperador no existe.';
                    WHEN -1407 THEN
                        -- Valor nulo
                        resultado := 'ERROR: Se ha intentado actualizar a un valor nulo ' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -20000 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El teleoperador est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END UPD_TELEOPERADOR;


    -- RF32
    PROCEDURE GET_TELEOPERADOR( pId IN BD.TELEOPERADORES.IDTELEOPERADOR%TYPE
                              , rs OUT SYS_REFCURSOR)
    IS
    /*
        RF32 - CASO DE USO: CONSULTAR TELEOPERADOR
        PARAMETROS ENTRADA:
            pId: identificador del teleoperador
                valor nulo devolver todos los registros.   
        PARAMETROS SALIDA:
            rs: cursor con el/los registro obtenido
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        resultado     BD.LOG.RESULTADO%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.GET_TELEOPERADOR';
        paramIN       := 'pId = ' || pId;
        dateIN        := SYSDATE;
        resultado     := 'OK. El(Los) teleoperador(es) se ha(n) consultado con xito';

        -- Realizamos la consulta en funcin del parmetro de entrada
        IF (pId IS NULL) THEN
            OPEN rs FOR
            SELECT * FROM TELEOPERADORES;
        ELSE
            OPEN rs FOR
            SELECT * FROM TELEOPERADORES WHERE idTeleoperador = pId;
        END IF; 
        
        -- Asignamos valores salida
        paramOUT      := 'rs = Cursor de Teleoperadores.';
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: Registro(s) no encontrado(s).';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Generamos un cursor vacio
                OPEN rs FOR
                SELECT * FROM DUAL WHERE DUMMY IS NULL;
                
                -- Asignamos valores salida
                paramOUT      := 'rs = Cursor vaco.';
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END GET_TELEOPERADOR;



/*
    TECNICOS
*/     
    -- RF33
    PROCEDURE INS_TECNICO( pNombre IN BD.TECNICOS.NOMBRE%TYPE
                         , pApellidos IN BD.TECNICOS.APELLIDOS%TYPE
                         , pNif IN BD.TECNICOS.NIF%TYPE
                         , pTelMovil IN BD.TECNICOS.TELMOVIL%TYPE
                         , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF33 - CASO DE USO: CREAR TECNICO
        PARAMETROS ENTRADA:
            pNombre:    Nombre del tcnico
            pApellidos: Apellidos del tcnico
            pNif:       NIF del tcnico
            pTelMovil:  Telfonoc mvil del tcnico
        PARAMETROS SALIDA:
            resultado: Informacin del resultado de la operacin.
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT|| '.INS_TECNICO';
        paramIN       := 'pNombre = ' || pNombre
                      || ', pApellidos = ' || pApellidos
                      || ', pNif = ' || pNif 
                      || ', pTelMovil = ' || pNif; 
        dateIN        := SYSDATE;
        resultado     := 'OK. El tcnico se ha creado con xito';

        -- Insertamos el tcnico
        INSERT INTO TECNICOS(nombre, apellidos, nif, telMovil) 
        VALUES(UPPER(pNombre), UPPER(pApellidos), UPPER(pNif), pTelMovil);
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -1 THEN
                        -- Registro duplicado
                        resultado := 'ERROR: El nif del tcnico ya existe.';
                    WHEN -1400 THEN
                        -- Valor nulo
                        resultado := 'ERROR: Se ha intentado almacenar un valor nulo.' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' || SQLCODE || ' - ' || SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END INS_TECNICO;


    -- RF34
    PROCEDURE DEL_TECNICO( pId IN BD.TECNICOS.IDTECNICO%TYPE 
                         , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF34 - CASO DE USO: BAJA TECNICO
        PARAMETROS ENTRADA:
            pId: Identificador del tcnico
        PARAMETROS SALIDA:
            resultado: Informacin del resultado de la operacin.
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fechaBaja     BD.TECNICOS.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT|| '.DEL_TECNICO';
        paramIN       := 'pId =' || pId;
        dateIN        := SYSDATE;
        resultado     := 'OK. El tcnico se ha dado de baja con xito';

        -- Miramos que exista y que no est de baja
        SELECT fxBaja INTO fechaBaja 
        FROM TECNICOS 
        WHERE idTecnico = pId;
        
        IF (fechaBaja IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20000,'');        
        END IF;
        
        -- Damos de baja el tcnico con fecha del sistema
        UPDATE TECNICOS 
        SET fxBaja = SYSDATE
        WHERE idTecnico = pId;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: El identificador del tcnico no existe.';
                    WHEN -20000 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El tcnico ya est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END DEL_TECNICO;


    -- RF35
    PROCEDURE RES_TECNICO( pId IN BD.TECNICOS.IDTECNICO%TYPE 
                         , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF35 - CASO DE USO: RECUPERAR TECNICO
        PARAMETROS ENTRADA:
            pId: Identificador del tcnico
        PARAMETROS SALIDA:
            resultado: Informacin del resultado de la operacin.
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fechaBaja     BD.TECNICOS.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.RES_TECNICO';
        paramIN       := 'pId =' || pId;
        dateIN        := SYSDATE;
        resultado     := 'OK. El tcnico se ha recuperado con xito';

        -- Miramos que exista y que est de baja
        SELECT fxBaja INTO fechaBaja 
        FROM TECNICOS 
        WHERE idTecnico = pId;
        
        IF (fechaBaja IS NULL) THEN
            RAISE_APPLICATION_ERROR(-20000,'');        
        END IF;
        
        --  Recuperamos al tcnico con fecha del sistema
        UPDATE TECNICOS 
        SET fxBaja = NULL
        WHERE idTecnico = pId;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: El identificador del tcnico no existe.';
                    WHEN -20000 THEN
                        -- Tcnico no dado de baja
                        resultado := 'ERROR: El tcnico no est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END RES_TECNICO;


    -- RF36
    PROCEDURE UPD_TECNICO( pId IN BD.TECNICOS.IDTECNICO%TYPE
                         , pNombre IN BD.TECNICOS.NOMBRE%TYPE
                         , pApellidos IN BD.TECNICOS.APELLIDOS%TYPE
                         , pNif IN BD.TECNICOS.NIF%TYPE
                         , pTelMovil IN BD.TECNICOS.TELMOVIL%TYPE
                         , resultado OUT BD.LOG.RESULTADO%TYPE ) 
    IS
    /*
        RF36 - CASO DE USO: MODIFICAR TECNICO
        PARAMETROS ENTRADA:
            pId: identificador del tcnico
            pNombre: nuevo nombre del tcnico
            pApellidos: nuevos apellidos del tcnico
            pNif: nuevo NIF del tcnico
            pTelMovil: nuevo telfono mvil del tcnico
        PARAMETROS SALIDA:
            ninguno
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fechaBaja     BD.TECNICOS.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.UPD_TECNICO';
        paramIN       := 'pId = ' || pId
                      || ' ,pNombre = ' || pNombre
                      || ' ,pApellidos = ' || pApellidos
                      || ' ,pNif = ' || pNif;
        dateIN        := SYSDATE;
        resultado     := 'OK. El tcnico se ha modificado con xito';

        -- Miramos que exista y que no est de baja
        SELECT fxBaja INTO fechaBaja 
        FROM TECNICOS 
        WHERE idTecnico = pId;
        
        IF (fechaBaja IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20000,'');        
        END IF;
        
        --  Modidicamos los datos del Tcnico (nombre, apellidos, nif, telMovil)
        UPDATE TECNICOS
        SET nombre = UPPER(pNombre)
          , apellidos = UPPER(pApellidos)
          , nif = UPPER(pNif)
          , telMovil = pTelMovil
        WHERE idTecnico = pId;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -1 THEN
                        -- Registro duplicado
                        resultado := 'ERROR: El nif del tcnico ya existe.';
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: El identificador del tcnico no existe.';
                    WHEN -1407 THEN
                        -- Valor nulo
                        resultado := 'ERROR: Se ha intentado actualizar a un valor nulo ' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -20000 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El tcnico est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END UPD_TECNICO;


    -- RF37
    PROCEDURE GET_TECNICO( pId IN BD.TECNICOS.IDTECNICO%TYPE
                         , rs OUT SYS_REFCURSOR)
    IS
    /*
        RF37 - CASO DE USO: CONSULTAR TECNICO
        PARAMETROS ENTRADA:
            pId: identificador del tcnico
                valor nulo devolver todos los registros.   
        PARAMETROS SALIDA:
            rs: cursor con el/los registro obtenido
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        resultado     BD.LOG.RESULTADO%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.GET_TECNICO';
        paramIN       := 'pId = ' || pId;
        dateIN        := SYSDATE;
        resultado     := 'OK. El(Los) tcnico(s) se ha(n) consultado con xito';

        -- Realizamos la consulta en funcin del parmetro de entrada
        IF (pId IS NULL) THEN
            OPEN rs FOR
            SELECT * FROM TECNICOS;
        ELSE
            OPEN rs FOR
            SELECT * FROM TECNICOS WHERE idTecnico = pId;
        END IF; 
        
        -- Asignamos valores salida
        paramOUT      := 'rs = Cursor de Tcnicos.';
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: Registro(s) no encontrado(s).';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Generamos un cursor vacio
                OPEN rs FOR
                SELECT * FROM DUAL WHERE DUMMY IS NULL;
                
                -- Asignamos valores salida
                paramOUT      := 'rs = Cursor vaco.';
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END GET_TECNICO;


 -- RF38
    PROCEDURE ASG_SERVICIOTECNICO( pIdServicio IN BD.SERVICIOS.IDSERVICIO%TYPE
                                 , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                 , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF38 - CASO DE USO: ASIGNAR SERVICIO A TECNICO
        PARAMETROS ENTRADA:
            pIdServicio:    Identificador de Servicio
            pIdTecnico:     Identificador de Tcnico
        PARAMETROS SALIDA:
            ninguno
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fxBajaSer     BD.SERVICIOS.FXBAJA%TYPE;
        fxBajaTec     BD.TECNICOS.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.ASG_SERVICIOTECNICO';
        paramIN       := 'pIdServicio = ' || pIdServicio
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. La asignacin se ha realizado con xito';

        -- Miramos si el servicio exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaSer
            FROM SERVICIOS
            WHERE idServicio = pIdServicio;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20000,'');
                END IF; 
        END;        
        
        IF (fxBajaSer IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20001,'');        
        END IF;

        -- Miramos si el tcnico exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaTec
            FROM TECNICOS
            WHERE idTecnico = pIdTecnico;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20010,'');
                END IF; 
        END;        
        
        IF (fxBajaTec IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20011,'');        
        END IF;

        --  Asignamos el servicio al tcnico
        INSERT INTO TECNICOSSERVICIOS(idTecnico, idServicio)
        VALUES (pIdTecnico, pIdServicio);
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -1 THEN
                        -- Registro duplicado
                        resultado := 'ERROR: El servicio ya est asociado al tcnico.';
                    WHEN -20000 THEN
                        -- Servicio no existe
                        resultado := 'ERROR: El identificador de servicio no existe.';
                    WHEN -20001 THEN
                        -- Servicio dado de baja
                        resultado := 'ERROR: El servicio est de baja.';
                    WHEN -20010 THEN
                        -- Tcnico no existe
                        resultado := 'ERROR: El identificador de tcnico no existe.';
                    WHEN -20011 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El tcnico est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END ASG_SERVICIOTECNICO;


    -- RF39
    PROCEDURE DSG_SERVICIOTECNICO( pIdServicio IN BD.SERVICIOS.IDSERVICIO%TYPE
                                 , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                 , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF39 - CASO DE USO: DESASIGNAR SERVICIO A TECNICO
        PARAMETROS ENTRADA:
            pIdServicio:    Identificador de Servicio
            pIdTecnico:     Identificador de Tcnico
        PARAMETROS SALIDA:
            ninguno
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fxBajaSer     BD.SERVICIOS.FXBAJA%TYPE;
        fxBajaTec     BD.TECNICOS.FXBAJA%TYPE;

    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.DSG_SERVICIOTECNICO';
        paramIN       := 'pIdServicio = ' || pIdServicio
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. La desasignacin se ha realizado con xito';

        -- Miramos si el servicio exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaSer
            FROM SERVICIOS
            WHERE idServicio = pIdServicio;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20000,'');
                END IF; 
        END;        
        
        IF (fxBajaSer IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20001,'');        
        END IF;

        -- Miramos si el tcnico exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaTec
            FROM TECNICOS
            WHERE idTecnico = pIdTecnico;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20010,'');
                END IF; 
        END;        
        
        IF (fxBajaTec IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20011,'');        
        END IF;

        --  Desasignamos el servicio al Tcnico
        DELETE FROM TECNICOSSERVICIOS
        WHERE idTecnico = pIdTecnico
        AND idServicio = pIdServicio;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -20000 THEN
                        -- Servicio no existe
                        resultado := 'ERROR: El identificador de servicio no existe.';
                    WHEN -20001 THEN
                        -- Servicio dado de baja
                        resultado := 'ERROR: El servicio est de baja.';
                    WHEN -20010 THEN
                        -- Tcnico no existe
                        resultado := 'ERROR: El identificador de tcnico no existe.';
                    WHEN -20011 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El tcnico est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END DSG_SERVICIOTECNICO;


    -- RF40
    PROCEDURE GET_SERVICIOSTECNICO( pIdServicio IN BD.SERVICIOS.IDSERVICIO%TYPE
                                  , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                  , rs OUT SYS_REFCURSOR)
    IS
    /*
        RF40 - CASO DE USO: CONSULTAR SERVICIOS DE TECNICO
        PARAMETROS ENTRADA:
            pIdServicio: identificador del servicio
                valor nulo devolver todos los servicios.
            pIdTecnico: identificador del tcnico
                valor nulo devolver todos los tcnicos.
        PARAMETROS SALIDA:
            rs: cursor con el/los registro obtenido
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        resultado     BD.LOG.RESULTADO%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.GET_SERVICIOSTECNICO';
        paramIN       := 'pIdServicio = ' || pIdServicio
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. El(Los) tcnico(s) se ha(n) consultado con xito';

        -- Realizamos la consulta en funcin del parmetro de entrada
        IF (pIdTecnico IS NULL) THEN
            IF (pIdServicio IS NULL) THEN 
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , S.idServicio 
                     , S.dsServicio
                FROM TECNICOSSERVICIOS TS
                     INNER JOIN TECNICOS T ON TS.idTecnico = T.idTecnico
                     INNER JOIN SERVICIOS S ON TS.idServicio = S.idServicio;
            ELSE
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , S.idServicio 
                     , S.dsServicio
                FROM TECNICOSSERVICIOS TS
                     INNER JOIN TECNICOS T ON TS.idTecnico = T.idTecnico
                     INNER JOIN SERVICIOS S ON TS.idServicio = S.idServicio
                WHERE TS.idServicio = pIdServicio;
            END IF;
        ELSE
            IF (pIdServicio IS NULL) THEN 
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , S.idServicio 
                     , S.dsServicio
                FROM TECNICOSSERVICIOS TS
                     INNER JOIN TECNICOS T ON TS.idTecnico = T.idTecnico
                     INNER JOIN SERVICIOS S ON TS.idServicio = S.idServicio
                WHERE TS.idTecnico = pIdTecnico;
            ELSE
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , S.idServicio 
                     , S.dsServicio
                FROM TECNICOSSERVICIOS TS
                     INNER JOIN TECNICOS T ON TS.idTecnico = T.idTecnico
                     INNER JOIN SERVICIOS S ON TS.idServicio = S.idServicio
                WHERE TS.idTecnico = pIdTecnico 
                AND TS.idServicio = pIdServicio;
            END IF;
        END IF; 
        
        -- Asignamos valores salida
        paramOUT      := 'rs = Cursor de Servicio(s) de Tcnico(s).';
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: Registro(s) no encontrado(s).';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Generamos un cursor vacio
                OPEN rs FOR
                SELECT * FROM DUAL WHERE DUMMY IS NULL;
                
                -- Asignamos valores salida
                paramOUT      := 'rs = Cursor vaco.';
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END GET_SERVICIOSTECNICO;


 -- RF41
    PROCEDURE ASG_ELECTRODOMESTICOTECNICO( pIdElectrodomestico IN BD.ELECTRODOMESTICOS.IDELECTRODOMESTICO%TYPE
                                         , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                         , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF41 - CASO DE USO: ASIGNAR ELECTRODOMESTICO A TECNICO
        PARAMETROS ENTRADA:
            pIdElectrodomestico:Identificador de Electrodomstico
            pIdTecnico:         Identificador de Tcnico
        PARAMETROS SALIDA:
            ninguno
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fxBajaEle     BD.ELECTRODOMESTICOS.FXBAJA%TYPE;
        fxBajaTec     BD.TECNICOS.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.ASG_ELECTRODOMESTICOTECNICO';
        paramIN       := 'pIdElectrodomestico = ' || pIdElectrodomestico
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. La asignacin se ha realizado con xito';

        -- Miramos si el servicio exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaEle
            FROM ELECTRODOMESTICOS
            WHERE idElectrodomestico = pIdElectrodomestico;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20000,'');
                END IF; 
        END;        
        
        IF (fxBajaEle IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20001,'');        
        END IF;

        -- Miramos si el tcnico exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaTec
            FROM TECNICOS
            WHERE idTecnico = pIdTecnico;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20010,'');
                END IF; 
        END;        
        
        IF (fxBajaTec IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20011,'');        
        END IF;

        --  Asignamos el servicio al tcnico
        INSERT INTO TECNICOSELECTRODOMESTICOS(idTecnico, idElectrodomestico)
        VALUES (pIdTecnico, pIdElectrodomestico);
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -1 THEN
                        -- Registro duplicado
                        resultado := 'ERROR: El electrodomstico ya est asociado al tcnico.';
                    WHEN -20000 THEN
                        -- Electrodomstico no existe
                        resultado := 'ERROR: El identificador de electrodomstico no existe.';
                    WHEN -20001 THEN
                        -- Electrodomstico dado de baja
                        resultado := 'ERROR: El electrodomstico est de baja.';
                    WHEN -20010 THEN
                        -- Tcnico no existe
                        resultado := 'ERROR: El identificador de tcnico no existe.';
                    WHEN -20011 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El tcnico est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END ASG_ELECTRODOMESTICOTECNICO;


    -- RF42
    PROCEDURE DSG_ELECTRODOMESTICOTECNICO( pIdElectrodomestico IN BD.ELECTRODOMESTICOS.IDELECTRODOMESTICO%TYPE
                                         , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                         , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF39 - CASO DE USO: DESASIGNAR ELECTRODOMESTICO A TECNICO
        PARAMETROS ENTRADA:
            pIdElectrodomestico:Identificador de Electrodomstico
            pIdTecnico:         Identificador de Tcnico
        PARAMETROS SALIDA:
            ninguno
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fxBajaEle     BD.ELECTRODOMESTICOS.FXBAJA%TYPE;
        fxBajaTec     BD.TECNICOS.FXBAJA%TYPE;

    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.DSG_ELECTRODOMESTICOTECNICO';
        paramIN       := 'pIdElectrodomestico = ' || pIdElectrodomestico
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. La desasignacin se ha realizado con xito';

        -- Miramos si el servicio exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaEle
            FROM ELECTRODOMESTICOS
            WHERE idElectrodomestico = pIdElectrodomestico;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20000,'');
                END IF; 
        END;        
        
        IF (fxBajaEle IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20001,'');        
        END IF;

        -- Miramos si el tcnico exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaTec
            FROM TECNICOS
            WHERE idTecnico = pIdTecnico;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20010,'');
                END IF; 
        END;        
        
        IF (fxBajaTec IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20011,'');        
        END IF;

        --  Desasignamos el electrodomstico al Tcnico
        DELETE FROM TECNICOSELECTRODOMESTICOS
        WHERE idTecnico = pIdTecnico
        AND idElectrodomestico = pIdElectrodomestico;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -20000 THEN
                        -- Electrodomstico no existe
                        resultado := 'ERROR: El identificador de electrodomstico no existe.';
                    WHEN -20001 THEN
                        -- Electrodomstico dado de baja
                        resultado := 'ERROR: El electrodomstico est de baja.';
                    WHEN -20010 THEN
                        -- Tcnico no existe
                        resultado := 'ERROR: El identificador de tcnico no existe.';
                    WHEN -20011 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El tcnico est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END DSG_ELECTRODOMESTICOTECNICO;


    -- RF43
    PROCEDURE GET_ELECTRODOMESTICOSTECNICO( pIdElectrodomestico IN BD.ELECTRODOMESTICOS.IDELECTRODOMESTICO%TYPE
                                          , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                                          , rs OUT SYS_REFCURSOR)
    IS
    /*
        RF43 - CASO DE USO: CONSULTAR ELECTRODOMESTICOS  DE TECNICO
        PARAMETROS ENTRADA:
            pIdElectrodomestico: identificador del Electrodomestico
                valor nulo devolver todos los servicios.
            pIdTecnico: identificador del tcnico
                valor nulo devolver todos los tcnicos.
        PARAMETROS SALIDA:
            rs: cursor con el/los registro obtenido
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        resultado     BD.LOG.RESULTADO%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.GET_ELECTRODOMESTICOSTECNICO';
        paramIN       := 'pIdElectrodomestico = ' || pIdElectrodomestico
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. El(Los) tcnico(s) se ha(n) consultado con xito';

        -- Realizamos la consulta en funcin del parmetro de entrada
        IF (pIdTecnico IS NULL) THEN
            IF (pIdElectrodomestico IS NULL) THEN 
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , E.idElectrodomestico 
                     , E.dsElectrodomestico
                FROM TECNICOSELECTRODOMESTICOS TE
                     INNER JOIN TECNICOS T ON TE.idTecnico = T.idTecnico
                     INNER JOIN ELECTRODOMESTICOS E ON TE.idElectrodomestico = E.idElectrodomestico;
            ELSE
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , E.idElectrodomestico 
                     , E.dsElectrodomestico
                FROM TECNICOSELECTRODOMESTICOS TE
                     INNER JOIN TECNICOS T ON TE.idTecnico = T.idTecnico
                     INNER JOIN ELECTRODOMESTICOS E ON TE.idElectrodomestico = E.idElectrodomestico
                WHERE TE.idElectrodomestico = pIdElectrodomestico;
            END IF;
        ELSE
            IF (pIdElectrodomestico IS NULL) THEN 
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , E.idElectrodomestico 
                     , E.dsElectrodomestico
                FROM TECNICOSELECTRODOMESTICOS TE
                     INNER JOIN TECNICOS T ON TE.idTecnico = T.idTecnico
                     INNER JOIN ELECTRODOMESTICOS E ON TE.idElectrodomestico = E.idElectrodomestico
                WHERE TE.idTecnico = pIdTecnico; 
            ELSE
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , E.idElectrodomestico 
                     , E.dsElectrodomestico
                FROM TECNICOSELECTRODOMESTICOS TE
                     INNER JOIN TECNICOS T ON TE.idTecnico = T.idTecnico
                     INNER JOIN ELECTRODOMESTICOS E ON TE.idElectrodomestico = E.idElectrodomestico
                WHERE TE.idTecnico = pIdTecnico 
                AND TE.idElectrodomestico = pIdElectrodomestico;
            END IF;
        END IF; 
        
        -- Asignamos valores salida
        paramOUT      := 'rs = Cursor de Electrodomstico(s) de Tcnico(s).';
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: Registro(s) no encontrado(s).';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Generamos un cursor vacio
                OPEN rs FOR
                SELECT * FROM DUAL WHERE DUMMY IS NULL;
                
                -- Asignamos valores salida
                paramOUT      := 'rs = Cursor vaco.';
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END GET_ELECTRODOMESTICOSTECNICO;


 -- RF44
    PROCEDURE ASG_ZONATECNICO( pIdZona IN BD.ZONAS.IDZONA%TYPE
                             , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                             , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF44 - CASO DE USO: ASIGNAR ZONA A TECNICO
        PARAMETROS ENTRADA:
            pIdZona:    Identificador de Zona
            pIdTecnico: Identificador de Tcnico
        PARAMETROS SALIDA:
            ninguno
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fxBajaTec     BD.TECNICOS.FXBAJA%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.ASG_ZONATECNICO';
        paramIN       := 'pIdZona = ' || pIdZona
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. La asignacin se ha realizado con xito';

        -- Miramos si el tcnico exite y est de alta
        SELECT fxBaja INTO fxBajaTec
        FROM TECNICOS
        WHERE idTecnico = pIdTecnico;
        
        IF (fxBajaTec IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20000,'');        
        END IF;

        --  Asignamos la zona al tcnico
        INSERT INTO TECNICOSZONAS(idTecnico, idZona)
        VALUES (pIdTecnico, pIdZona);
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -1 THEN
                        -- Registro duplicado
                        resultado := 'ERROR: La zona ya est asociada al tcnico.';
                    WHEN 100 THEN 
                        -- Registro no encontrado
                        resultado := 'ERROR: El identificador de tcnico no existe.';
                    WHEN -2291 THEN
                        -- Restriccin de integridad
                        resultado := 'ERROR: El identificador de zona no existe.';
                    WHEN -20000 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El tcnico est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END ASG_ZONATECNICO;


    -- RF45
    PROCEDURE DSG_ZONATECNICO( pIdzona IN BD.ZONAS.IDZONA%TYPE
                             , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                             , resultado OUT BD.LOG.RESULTADO%TYPE )
    IS
    /*
        RF45 - CASO DE USO: DESASIGNAR ZONA A TECNICO
        PARAMETROS ENTRADA:
            pIdZona:    Identificador de Zona
            pIdTecnico: Identificador de Tcnico
        PARAMETROS SALIDA:
            ninguno
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        fxBajaTec     BD.TECNICOS.FXBAJA%TYPE;
        iZona         BD.ZONAS.IDZONA%TYPE;

    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.DSG_ZONATECNICO';
        paramIN       := 'pIdZona = ' || pIdZona
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. La asignacin se ha realizado con xito';

        -- Miramos si la zona exite 
        BEGIN
            SELECT idZona INTO iZona
            FROM ZONAS
            WHERE idZona = pIdZona;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20000,'');
                END IF; 
        END;        

        -- Miramos si el tcnico exite y est de alta
        BEGIN
            SELECT fxBaja INTO fxBajaTec
            FROM TECNICOS
            WHERE idTecnico = pIdTecnico;
        EXCEPTION
            WHEN OTHERS THEN
                IF (SQLCODE = 100) THEN
                    -- Registro No encontrado
                    RAISE_APPLICATION_ERROR(-20010,'');
                END IF; 
        END;        
        
        IF (fxBajaTec IS NOT NULL) THEN
            RAISE_APPLICATION_ERROR(-20011,'');        
        END IF;


        --  Desasignamos la zona al Tcnico
        DELETE FROM TECNICOSZONAS
        WHERE idTecnico = pIdTecnico
        AND idZona = pIdZona;
        
        -- Asignamos valores salida
        paramOUT      := 'resultado = ' || resultado;
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN -20000 THEN
                        -- Zona no existe
                        resultado := 'ERROR: El identificador de zona no existe.';
                    WHEN -20010 THEN
                        -- Tcnico no existe
                        resultado := 'ERROR: El identificador de tcnico no existe.';
                    WHEN -20011 THEN
                        -- Tcnico dado de baja
                        resultado := 'ERROR: El tcnico est de baja.';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Asignamos valores salida
                paramOUT      := 'resultado = ' || resultado;
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END DSG_ZONATECNICO;


    -- RF46
    PROCEDURE GET_ZONASTECNICO( pIdZona IN BD.ZONAS.IDZONA%TYPE
                              , pIdTecnico IN BD.TECNICOS.IDTECNICO%TYPE
                              , rs OUT SYS_REFCURSOR)
    IS
    /*
        RF46 - CASO DE USO: CONSULTAR ZONAS DE TECNICO
        PARAMETROS ENTRADA:
            pIdZona: identificador de la Zona
                valor nulo devolver todos los servicios.
            pIdTecnico: identificador del tcnico
                valor nulo devolver todos los tcnicos.
        PARAMETROS SALIDA:
            rs: cursor con el/los registro obtenido
    */
        procedimiento BD.LOG.PROCEDIMIENTO%TYPE;
        paramIN       BD.LOG.PARAMIN%TYPE;
        paramOUT      BD.LOG.PARAMOUT%TYPE;
        dateIN        BD.LOG.FXIN%TYPE;
        dateOUT       BD.LOG.FXOUT%TYPE;
        resultado     BD.LOG.RESULTADO%TYPE;
    BEGIN
    
        -- Asignamos valores entrada
        procedimiento := $$PLSQL_UNIT || '.GET_ZONASTECNICO';
        paramIN       := 'pIdZona = ' || pIdZona
                      || ' ,pIdTecnico = ' || pIdTecnico;
        dateIN        := SYSDATE;
        resultado     := 'OK. El(Los) tcnico(s) se ha(n) consultado con xito';

        -- Realizamos la consulta en funcin del parmetro de entrada
        IF (pIdTecnico IS NULL) THEN
            IF (pIdZona IS NULL) THEN 
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , Z.idZona 
                     , Z.dsZona
                FROM TECNICOSZONAS TZ
                     INNER JOIN TECNICOS T ON TZ.idTecnico = T.idTecnico
                     INNER JOIN ZONAS Z ON TZ.idZona = Z.idZona;
            ELSE
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , Z.idZona 
                     , Z.dsZona
                FROM TECNICOSZONAS TZ
                     INNER JOIN TECNICOS T ON TZ.idTecnico = T.idTecnico
                     INNER JOIN ZONAS Z ON TZ.idZona = Z.idZona
                WHERE TZ.idZona = pIdZona;
            END IF;
        ELSE
            IF (pIdZona IS NULL) THEN 
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , Z.idZona 
                     , Z.dsZona
                FROM TECNICOSZONAS TZ
                     INNER JOIN TECNICOS T ON TZ.idTecnico = T.idTecnico
                     INNER JOIN ZONAS Z ON TZ.idZona = Z.idZona
                WHERE TZ.idTecnico = pIdTecnico; 
            ELSE
                OPEN rs FOR
                SELECT T.idTecnico
                     , T.nombre
                     , T.apellidos
                     , Z.idZona 
                     , Z.dsZona
                FROM TECNICOSZONAS TZ
                     INNER JOIN TECNICOS T ON TZ.idTecnico = T.idTecnico
                     INNER JOIN ZONAS Z ON TZ.idZona = Z.idZona
                WHERE TZ.idTecnico = pIdTecnico 
                AND TZ.idZona = pIdZona;
            END IF;
        END IF; 
        
        -- Asignamos valores salida
        paramOUT      := 'rs = Cursor de Zonas(s) de Tcnico(s).';
        dateOUT       := SYSDATE;
        
        -- Grabamos en el LOG
        CONTROL.GRABA_LOG( procedimiento
                         , paramIN
                         , paramOUT 
                         , dateIN
                         , dateOUT
                         , resultado );
         
         EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                    WHEN 100 THEN
                        -- Registro no encontrado
                        resultado := 'ERROR: Registro(s) no encontrado(s).';
                    ELSE
                        -- Error no controlado
                        resultado := 'ERROR: ' ||  SQLERRM;
                END CASE;            

                -- Generamos un cursor vacio
                OPEN rs FOR
                SELECT * FROM DUAL WHERE DUMMY IS NULL;
                
                -- Asignamos valores salida
                paramOUT      := 'rs = Cursor vaco.';
                dateOUT       := SYSDATE;
                
                -- Mensaje de error
                DBMS_OUTPUT.put_line (resultado);

                -- Grabamos en el LOG
                CONTROL.GRABA_LOG( procedimiento
                                 , paramIN
                                 , paramOUT 
                                 , dateIN
                                 , dateOUT
                                 , resultado );
    END GET_ZONASTECNICO;


END PERSONAL;

