/*
    PACKAGE TEST_PERSONAL
    Fecha: 26/04/2011
    Autor: Francisco Amador Risquez Teva
    Proyecto: gPV
*/



/*
    ESPECIFICACIN DEL PAQUETE
    TEST_PERSONAL
*/
CREATE OR REPLACE PACKAGE BD.TEST_PERSONAL AS

    --TEST06
    PROCEDURE TEST_TELEOPERADORES;
    
    --TEST07
    PROCEDURE TEST_TECNICOS;


END TEST_PERSONAL;

    

/*
    CUERPO DEL PAQUETE
    TEST_PERSONAL
*/
CREATE OR REPLACE PACKAGE BODY BD.TEST_PERSONAL AS

    -- TEST06
    PROCEDURE TEST_TELEOPERADORES 
    IS
    resultado BD.LOG.RESULTADO%TYPE;
    BEGIN
        /*
            RF28 INS_TELEOPERADOR
        */
        --Insertamos Teleoperador de forma correcta
        PERSONAL.INS_TELEOPERADOR('TELE_01', 'OPERADOR_01', '11111111A', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Teleoperador de forma correcta
        PERSONAL.INS_TELEOPERADOR('TELE_02', 'OPERADOR_02', '22222222B', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Teleoperador de forma correcta
        PERSONAL.INS_TELEOPERADOR('TELE_03', 'OPERADOR_03', '33333333C', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Teleoperador con NIF existente
        PERSONAL.INS_TELEOPERADOR('TELE_04', 'OPERADOR_04', '33333333C', resultado);

        --Insertamos Teleoperador con valores nulos
        PERSONAL.INS_TELEOPERADOR( NULL, 'OPERADOR_04', '44444444D', resultado);
        PERSONAL.INS_TELEOPERADOR('TELE_04', NULL, '44444444D', resultado);
        PERSONAL.INS_TELEOPERADOR('TELE_04', 'OPERADOR_04', NULL, resultado);

        
        /*
            RF29 DEL_TELEOPERADOR
        */
        --Damos de baja el Teleoprador de forma correcta
        PERSONAL.DEL_TELEOPERADOR(2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Damos de baja el Teleoprador de forma correcta
        PERSONAL.DEL_TELEOPERADOR(3, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Damos de baja un Teleoprador que no existe
        PERSONAL.DEL_TELEOPERADOR(8, resultado);
        
        --Damos de baja un Teleoprador que est de baja
        PERSONAL.DEL_TELEOPERADOR(3, resultado);


        /*
            RF30 RES_TELEOPERADOR
        */
        --Recuperamos el Teleoperador de forma correcta
        PERSONAL.RES_TELEOPERADOR(2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Recuperamos un Teleoperador que no existe
        PERSONAL.RES_TELEOPERADOR(8, resultado);
        
        --Recuperamos un Teleoperador que NO est de baja
        PERSONAL.RES_TELEOPERADOR(1, resultado);


        /*
            RF31 UPD_TELEOPERADOR
        */
        --Modificamos el Teleoperador de forma correcta
        PERSONAL.UPD_TELEOPERADOR(2,'TELE_02BIS', 'OPERADOR_02BIS', '22222222Z', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Modificamos un Teleoperador que no existe
        PERSONAL.UPD_TELEOPERADOR(8,'TELE_08BIS', 'OPERADOR_08BIS', '888888888H', resultado);
        
        --Modificamos un Teleopeador con un NIF existente
        PERSONAL.UPD_TELEOPERADOR(2,'TELE_02BIS', 'OPERADOR_02BIS', '11111111A', resultado);
        
        --Modificamos un Teleoperador con un valor nulo
        PERSONAL.UPD_TELEOPERADOR(2, NULL, 'OPERADOR_02BIS', '22222222Z', resultado);
        PERSONAL.UPD_TELEOPERADOR(2,'TELE_02BIS', NULL, '22222222Z', resultado);
        PERSONAL.UPD_TELEOPERADOR(2,'TELE_02BIS', 'OPERADOR_02BIS', NULL, resultado);

        --Modificamos un Teleoperador que est de baja
        PERSONAL.UPD_TELEOPERADOR(3,'TELE_03BIS', 'OPERADOR_03BIS', '33333333R', resultado);


    END TEST_TELEOPERADORES;



    -- TEST07
    PROCEDURE TEST_TECNICOS 
    IS
    resultado BD.LOG.RESULTADO%TYPE;
    BEGIN
        /*
            RF33 INS_TECNICO
        */
        --Insertamos Tcnico de forma correcta
        PERSONAL.INS_TECNICO('TEC_01', 'NICO_01', '11111111A', '611111111', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Tcnico de forma correcta
        PERSONAL.INS_TECNICO('TEC_02', 'NICO_02', '22222222B', '622222222', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Tcnico de forma correcta
        PERSONAL.INS_TECNICO('TEC_03', 'NICO_03', '33333333C', '633333333', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Tcnico con NIF existente
        PERSONAL.INS_TECNICO('TEC_04', 'NICO_04', '33333333C', '644444444', resultado);

        --Insertamos Tcnico con valores nulos
        PERSONAL.INS_TECNICO( NULL, 'NICO_04', '44444444D', '644444444', resultado);
        PERSONAL.INS_TECNICO('TEC_04', NULL, '44444444D', '644444444', resultado);
        PERSONAL.INS_TECNICO('TEC_04', 'NICO_04', NULL, '644444444', resultado);
        PERSONAL.INS_TECNICO('TEC_04', 'NICO_04', '44444444D', NULL, resultado);

        
        /*
            RF34 DEL_TECNICO
        */
        --Damos de baja el Tcnico de forma correcta
        PERSONAL.DEL_TECNICO(2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Damos de baja el Tcnico de forma correcta
        PERSONAL.DEL_TECNICO(3, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Damos de baja un Tcnico que no existe
        PERSONAL.DEL_TECNICO(8, resultado);
        
        --Damos de baja un Tcnico que est de baja
        PERSONAL.DEL_TECNICO(3, resultado);


        /*
            RF35 RES_TECNICO
        */
        --Recuperamos el Tcnico de forma correcta
        PERSONAL.RES_TECNICO(2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Recuperamos un Tcnico que no existe
        PERSONAL.RES_TECNICO(8, resultado);
        
        --Recuperamos un Tcnico que NO est de baja
        PERSONAL.RES_TECNICO(1, resultado);


        /*
            RF31 UPD_TECNICO
        */
        --Modificamos el Tcnico de forma correcta
        PERSONAL.UPD_TECNICO(2,'TEC_02BIS', 'NICO_02BIS', '22222222Z', '623232323', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Modificamos un Tcnico que no existe
        PERSONAL.UPD_TECNICO(8,'TEC_08BIS', 'NICO_08BIS', '888888888H', '688888888', resultado);
        
        --Modificamos un Tcnico con un NIF existente
        PERSONAL.UPD_TECNICO(2,'TEC_02BIS', 'NICO_02BIS', '11111111A','623232323', resultado);
        
        --Modificamos un Tcnico con un valor nulo
        PERSONAL.UPD_TECNICO(2, NULL, 'NICO_02BIS', '22222222Z', '623232323', resultado);
        PERSONAL.UPD_TECNICO(2,'TEC_02BIS', NULL, '22222222Z', '623232323', resultado);
        PERSONAL.UPD_TECNICO(2,'TEC_02BIS', 'NICO_02BIS', NULL, '623232323', resultado);
        PERSONAL.UPD_TECNICO(2,'TEC_02BIS', 'NICO_02BIS', '22222222Z', NULL, resultado);

        --Modificamos un Tcnico que est de baja
        PERSONAL.UPD_TECNICO(3,'TEC_03BIS', 'NICO_03BIS', '33333333R', '633333333', resultado);


        /*
            RF38 ASG_SERVICIOTECNICO
        */
        --Asignamos un servicio a una tcnico de forma correcta
        PERSONAL.ASG_SERVICIOTECNICO(1,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos un servicio a una tcnico de forma correcta
        PERSONAL.ASG_SERVICIOTECNICO(1,2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos un servicio a una tcnico de forma correcta
        PERSONAL.ASG_SERVICIOTECNICO(2,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos un Servicio que no existe a una Tcnico
        PERSONAL.ASG_SERVICIOTECNICO(8, 1, resultado);
        
        --Asignamos un Servicio a un Tcnico no existente
        PERSONAL.ASG_SERVICIOTECNICO(2, 88, resultado);

        --Asignamos un Servicio dado de baja a una Tcnico
        PERSONAL.ASG_SERVICIOTECNICO(3, 1, resultado);
        
        --Asignamos un Servicio a un Tcnico dado de baja
        PERSONAL.ASG_SERVICIOTECNICO(1, 3, resultado);

        --Asignamos un Servicio ya asignado al mismo Tcnico
        PERSONAL.ASG_SERVICIOTECNICO(1, 1, resultado);


        /*
            RF39 DSG_SERVICIOTECNICO
        */
        --Desasignamos un servicio a un Tcnico de forma correcta
        PERSONAL.DSG_SERVICIOTECNICO(2,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Desasignamos un Servicio que no existe a un Tcnico
        PERSONAL.DSG_SERVICIOTECNICO(88, 1, resultado);
        
        --Desasignamos un Servicio dado de baja a un Tcnico
        PERSONAL.DSG_SERVICIOTECNICO(3, 1, resultado);

        --Desasignamos un Servicio a un Tcnico no existente
        PERSONAL.DSG_SERVICIOTECNICO(1, 88, resultado);

        --Desasignamos un Servicio a un Tcnico dado de baja
        PERSONAL.DSG_SERVICIOTECNICO(1, 3, resultado);



        /*
            RF41 ASG_ELECTRODOMESTICOTECNICO
        */
        --Asignamos un electrodomestico a una tcnico de forma correcta
        PERSONAL.ASG_ELECTRODOMESTICOTECNICO(1,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos un electrodomestico a una tcnico de forma correcta
        PERSONAL.ASG_ELECTRODOMESTICOTECNICO(1,2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos un electrodomestico a una tcnico de forma correcta
        PERSONAL.ASG_ELECTRODOMESTICOTECNICO(2,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos un electrodomestico que no existe a una Tcnico
        PERSONAL.ASG_ELECTRODOMESTICOTECNICO(8, 1, resultado);
        
        --Asignamos un electrodomestico a un Tcnico no existente
        PERSONAL.ASG_ELECTRODOMESTICOTECNICO(2, 88, resultado);

        --Asignamos un electrodomestico dado de baja a una Tcnico
        PERSONAL.ASG_ELECTRODOMESTICOTECNICO(3, 1, resultado);
        
        --Asignamos un electrodomestico a un Tcnico dado de baja
        PERSONAL.ASG_ELECTRODOMESTICOTECNICO(1, 3, resultado);

        --Asignamos un electrodomestico ya asignado al mismo Tcnico
        PERSONAL.ASG_ELECTRODOMESTICOTECNICO(1, 1, resultado);


        /*
            RF42 DSG_ELECTRODOMESTICOTECNICO
        */
        --Desasignamos un electrodomestico a un Tcnico de forma correcta
        PERSONAL.DSG_ELECTRODOMESTICOTECNICO(2,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Desasignamos un electrodomestico que no existe a un Tcnico
        PERSONAL.DSG_ELECTRODOMESTICOTECNICO(88, 1, resultado);
        
        --Desasignamos un electrodomestico dado de baja a un Tcnico
        PERSONAL.DSG_ELECTRODOMESTICOTECNICO(3, 1, resultado);

        --Desasignamos un electrodomestico a un Tcnico no existente
        PERSONAL.DSG_ELECTRODOMESTICOTECNICO(1, 88, resultado);

        --Desasignamos un Servicio a un Tcnico dado de baja
        PERSONAL.DSG_ELECTRODOMESTICOTECNICO(1, 3, resultado);


        /*
            RF44 ASG_ZONATECNICO
        */
        --Asignamos una zona a una tcnico de forma correcta
        PERSONAL.ASG_ZONATECNICO(1,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos una zona a una tcnico de forma correcta
        PERSONAL.ASG_ZONATECNICO(1,2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos una zona a una tcnico de forma correcta
        PERSONAL.ASG_ZONATECNICO(2,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Asignamos una zona que no existe a una Tcnico
        PERSONAL.ASG_ZONATECNICO(8, 1, resultado);
        
        --Asignamos una zona a un Tcnico no existente
        PERSONAL.ASG_ZONATECNICO(2, 88, resultado);
       
        --Asignamos una zona a un Tcnico dado de baja
        PERSONAL.ASG_ZONATECNICO(1, 3, resultado);

        --Asignamos una zona ya asignado al mismo Tcnico
        PERSONAL.ASG_ZONATECNICO(1, 1, resultado);


        /*
            RF45 DSG_ZONATECNICO
        */
        --Desasignamos una zona a un Tcnico de forma correcta
        PERSONAL.DSG_ZONATECNICO(2,1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Desasignamos una zona que no existe a un Tcnico
        PERSONAL.DSG_ZONATECNICO(88, 1, resultado);
        
        --Desasignamos una zona a un Tcnico no existente
        PERSONAL.DSG_ZONATECNICO(1, 88, resultado);

        --Desasignamos una zona a un Tcnico dado de baja
        PERSONAL.DSG_ZONATECNICO(1, 3, resultado);


    END TEST_TECNICOS;



END TEST_PERSONAL;

