/*
    PACKAGE TEST_PETICION
    Fecha: 30/04/2011
    Autor: Francisco Amador Risquez Teva
    Proyecto: gPV
*/



/*
    ESPECIFICACIN DEL PAQUETE
    TEST_PETICION
*/
CREATE OR REPLACE PACKAGE BD.TEST_PETICION AS

    --TEST08
    PROCEDURE TEST_CLIENTES;
    
    --TEST09
    PROCEDURE TEST_PRODUCTOS;

    --TEST10
    PROCEDURE TEST_PETICIONES;


END TEST_PETICION;



/*
    CUERPO DEL PAQUETE
    TEST_PETICION
*/
CREATE OR REPLACE PACKAGE BODY BD.TEST_PETICION AS

    -- TEST08
    PROCEDURE TEST_CLIENTES 
    IS
    resultado BD.LOG.RESULTADO%TYPE;
    BEGIN
        /*
            RF47 INS_CLIENTE
        */
        --Insertamos Cliente de forma correcta
        PETICION.INS_CLIENTE('CLI_01', 'ENTE_01', '11111111A', 'CALLE_01', '01001', '911111111', '611111111', 'cli01@hotmail.com', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Cliente de forma correcta
        PETICION.INS_CLIENTE('CLI_02', 'ENTE_02', '22222222B', 'CALLE_02', '01001', '922222222', '622222222', 'cli02@hotmail.com', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Cliente de forma correcta
        PETICION.INS_CLIENTE('CLI_03', 'ENTE_03', '33333333C', 'CALLE_03', '01001', '933333333', '633333333', 'cli03@hotmail.com', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Cliente con NIF existente
        PETICION.INS_CLIENTE('CLI_04', 'ENTE_04', '33333333C', 'CALLE_04', '01001', '944444444', '633444444', 'cli04@hotmail.com', resultado);

        --Insertamos Cliente con valores nulos
        PETICION.INS_CLIENTE( NULL, 'ENTE_04', '44444444D', 'CALLE_04', '01001', '944444444', '633444444', 'cli04@hotmail.com', resultado);
        PETICION.INS_CLIENTE('CLI_04', NULL, '44444444D', 'CALLE_04', '01001', '944444444', '633444444', 'cli04@hotmail.com', resultado);
        PETICION.INS_CLIENTE('CLI_04', 'ENTE_04', NULL, 'CALLE_04', '01001', '944444444', '633444444', 'cli04@hotmail.com', resultado);
        PETICION.INS_CLIENTE('CLI_04', 'ENTE_04', '44444444D', NULL, '01001', '944444444', '633444444', 'cli04@hotmail.com', resultado);
        PETICION.INS_CLIENTE('CLI_04', 'ENTE_04', '44444444D', 'CALLE_04', NULL, '944444444', '633444444', 'cli04@hotmail.com', resultado);
        PETICION.INS_CLIENTE('CLI_04', 'ENTE_04', '44444444D', 'CALLE_04', '01001', NULL, '633444444', 'cli04@hotmail.com', resultado);
        PETICION.INS_CLIENTE('CLI_04', 'ENTE_04', '44444444D', 'CALLE_04', '01001', '944444444', NULL, 'cli04@hotmail.com', resultado);
        PETICION.INS_CLIENTE('CLI_04', 'ENTE_04', '44444444D', 'CALLE_04', '01001', '944444444', '633444444', NULL, resultado);
     
        --Insertamos Cliente con una poblacin(codPostal) no existente
        PETICION.INS_CLIENTE('CLI_04', 'ENTE_04', '44444444D', 'CALLE_04', '00000', '944444444', '633444444', 'cli04@hotmail.com', resultado);



        /*
            RF48 UPD_CLIENTE
        */
        --Modificamos el Cliente de forma correcta
        PETICION.UPD_CLIENTE(2,'CLI_02BIS', 'ENTE_02BIS', '22222222Z', 'CALLE_02BIS', '01001', '923232323', '623232323', 'cli_02@hotmail.com', resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Modificamos un Cliente que no existe
        PETICION.UPD_CLIENTE(88, 'CLI_02BIS', 'ENTE_02BIS', '22222222Z', 'CALLE_02BIS', '01001', '923232323', '623232323', 'cli_02@hotmail.com', resultado);
        
        --Modificamos un Cliente con un NIF existente
        PETICION.UPD_CLIENTE(2, 'CLI_02BIS', 'ENTE_02BIS', '33333333C', 'CALLE_02BIS', '01001', '923232323', '623232323', 'cli_02@hotmail.com', resultado);
        
        --Modificamos un Cliente con un valor nulo
        PETICION.UPD_CLIENTE(2, NULL, 'ENTE_02BIS', '22222222Z', 'CALLE_02BIS', '01001', '923232323', '623232323', 'cli_02@hotmail.com', resultado);
        PETICION.UPD_CLIENTE(2, 'CLI_02BIS', NULL, '22222222Z', 'CALLE_02BIS', '01001', '923232323', '623232323', 'cli_02@hotmail.com', resultado);
        PETICION.UPD_CLIENTE(2, 'CLI_02BIS', 'ENTE_02BIS', NULL, 'CALLE_02BIS', '01001', '923232323', '623232323', 'cli_02@hotmail.com', resultado);
        PETICION.UPD_CLIENTE(2, 'CLI_02BIS', 'ENTE_02BIS', '22222222Z', NULL, '01001', '923232323', '623232323', 'cli_02@hotmail.com', resultado);
        PETICION.UPD_CLIENTE(2, 'CLI_02BIS', 'ENTE_02BIS', '22222222Z', 'CALLE_02BIS', NULL, '923232323', '623232323', 'cli_02@hotmail.com', resultado);
        PETICION.UPD_CLIENTE(2, 'CLI_02BIS', 'ENTE_02BIS', '22222222Z', 'CALLE_02BIS', '01001', NULL, '623232323', 'cli_02@hotmail.com', resultado);
        PETICION.UPD_CLIENTE(2,'CLI_02BIS', 'ENTE_02BIS', '22222222Z', 'CALLE_02BIS', '01001', '923232323', NULL, 'cli_02@hotmail.com', resultado);
        PETICION.UPD_CLIENTE(2,'CLI_02BIS', 'ENTE_02BIS', '22222222Z', 'CALLE_02BIS', '01001', '923232323', '623232323', NULL, resultado);

        --Modificamos un Cliente con una Poblacin no existente
        PETICION.UPD_CLIENTE(2,'CLI_02BIS', 'ENTE_02BIS', '22222222Z', 'CALLE_02BIS', '00000', '923232323', '623232323', 'cli_02@hotmail.com', resultado);


    END TEST_CLIENTES;



    -- TEST09
    PROCEDURE TEST_PRODUCTOS 
    IS
    resultado BD.LOG.RESULTADO%TYPE;
    BEGIN
        /*
            RF50 INS_PRODUCTO
        */
        --Insertamos Producto de forma correcta
        PETICION.INS_PRODUCTO(1, 'MARCA_01', 'MODELO_01', 'SERIE_01', TO_DATE('01/01/2011','DD/MM/YYYY'), 'DIRECCION_01', '01001', 1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Producto de forma correcta
        PETICION.INS_PRODUCTO(2, 'MARCA_02', 'MODELO_02', 'SERIE_02', TO_DATE('02/02/2011','DD/MM/YYYY'), 'DIRECCION_02', '01002', 2, resultado);
           -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Producto con NumSerie existente
        PETICION.INS_PRODUCTO(1, 'MARCA_03', 'MODELO_03', 'SERIE_01', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '01003', 1, resultado);

        --Insertamos Producto con valores nulos
        PETICION.INS_PRODUCTO(1, NULL, 'MODELO_03', 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '01003', 1, resultado);
        PETICION.INS_PRODUCTO(1, 'MARCA_03', NULL, 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '01003', 1, resultado);
        PETICION.INS_PRODUCTO(1, 'MARCA_03', 'MODELO_03', NULL, TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '01003', 1, resultado);
        PETICION.INS_PRODUCTO(1, 'MARCA_03', 'MODELO_03', 'SERIE_03', NULL, 'DIRECCION_03', '01003', 1, resultado);
        PETICION.INS_PRODUCTO(1, 'MARCA_03', 'MODELO_03', 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), NULL, '01003', 1, resultado);
        PETICION.INS_PRODUCTO(1, 'MARCA_03', 'MODELO_03', 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', NULL, 1, resultado);
        PETICION.INS_PRODUCTO(1, 'MARCA_03', 'MODELO_03', 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '01003', NULL, resultado);
     
        --Insertamos Producto con un Electrodomstico no existente
        PETICION.INS_PRODUCTO(88, 'MARCA_03', 'MODELO_03', 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '01003', 1, resultado);

        --Insertamos Producto con un Electrodomstico dado de baja
        PETICION.INS_PRODUCTO(3, 'MARCA_03', 'MODELO_03', 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '01003', 1, resultado);

        --Insertamos Producto con una Poblacin(codPostal) no existente
        PETICION.INS_PRODUCTO(1, 'MARCA_03', 'MODELO_03', 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '00000', 1, resultado);

        --Insertamos Producto con un Cliente no existente
        PETICION.INS_PRODUCTO(1, 'MARCA_03', 'MODELO_03', 'SERIE_03', TO_DATE('03/03/2011','DD/MM/YYYY'), 'DIRECCION_03', '01003', 88, resultado);


        /*
            RF51 UPD_PRODUCTO
        */
        --Modificamos el Producto de forma correcta
        PETICION.UPD_PRODUCTO(2, 1, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Modificamos un Producto que no existe
        PETICION.UPD_PRODUCTO(88, 1, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 1, resultado);
        
        --Modificamos un Producto con un NumSerie existente
        PETICION.UPD_PRODUCTO(2, 1, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_01', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 1, resultado);
        
        --Modificamos un Producto con un valor nulo
        PETICION.UPD_PRODUCTO(2, 1, NULL, 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 1, resultado);
        PETICION.UPD_PRODUCTO(2, 1, 'MARCA_02BIS', NULL, 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 1, resultado);
        PETICION.UPD_PRODUCTO(2, 1, 'MARCA_02BIS', 'MODELO_02BIS', NULL, TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 1, resultado);
        PETICION.UPD_PRODUCTO(2, 1, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', NULL, 'DIRECCION_02BIS', '01001', 1, resultado);
        PETICION.UPD_PRODUCTO(2, 1, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), NULL, '01001', 1, resultado);
        PETICION.UPD_PRODUCTO(2, 1, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', NULL, 1, resultado);
        PETICION.UPD_PRODUCTO(2, 1, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', NULL, resultado);

        --Modificamos Producto con un Electrodomstico no existente
        PETICION.UPD_PRODUCTO(2, 88, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 1, resultado);

        --Modificamos Producto con un Electrodomstico dado de baja
        PETICION.UPD_PRODUCTO(2, 3, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 1, resultado);

        --Modificamos Producto con una Poblacin(codPostal) no existente
        PETICION.UPD_PRODUCTO(2, 2, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_02BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '00000', 1, resultado);

        --Modificamos Producto con un Cliente no existente
        PETICION.UPD_PRODUCTO(2, 2, 'MARCA_02BIS', 'MODELO_02BIS', 'SERIE_012BIS', TO_DATE('20/02/2011','DD/MM/YYYY'), 'DIRECCION_02BIS', '01001', 88, resultado);


    END TEST_PRODUCTOS;



    -- TEST10
    PROCEDURE TEST_PETICIONES 
    IS
    resultado BD.LOG.RESULTADO%TYPE;
    BEGIN
        /*
            RF51 INS_PETICION
        */
        --Insertamos Peticin de forma correcta
        PETICION.INS_PETICION(1, 1, 1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Peticin de forma correcta
        PETICION.INS_PETICION(1, 2, 1, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Peticin de forma correcta
        PETICION.INS_PETICION(2, 1, 2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Peticin de forma correcta
        PETICION.INS_PETICION(2, 2, 2, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Insertamos Peticin con un Producto no existente
        PETICION.INS_PETICION(88, 1, 1, resultado);

        --Insertamos Peticin con un Servicio no existente
        PETICION.INS_PETICION(1, 88, 1, resultado);

        --Insertamos Peticin con un Servicio dado de baja
        PETICION.INS_PETICION(1, 3, 1, resultado);

        --Insertamos Peticin con un Teleoperador no existente
        PETICION.INS_PETICION(1, 1, 88, resultado);

        --Insertamos Peticin con un Teleoperador dado de baja
        PETICION.INS_PETICION(1, 1, 3, resultado);


        /*
            RF54 CANCEL_PETICION
        */
        --Anulamos la peticin de forma correcta
        PETICION.CANCEL_PETICION(4, resultado);
        -- Resultado correcto
        DBMS_OUTPUT.put_line (resultado);

        --Anulamos peticin no existente
        PETICION.CANCEL_PETICION(88, resultado);

        --Anulamos peticin que no est pendiente
        PETICION.CANCEL_PETICION(4, resultado);


    END TEST_PETICIONES;


END TEST_PETICION;

